/** Generated by 'create-bundle.kts' */

/** ../include/zeus_api.h */

#ifndef CORE_API_H
#define CORE_API_H

#include <zeus_config.h>

/** #include "src/zeus_communication.h" expanded with it's source */

#ifndef CORE_COMMUNICATION_H
#define CORE_COMMUNICATION_H

#include <zeus_config.h>
#include <stdbool.h>
#include <stdint.h>

struct ZeusClient;
typedef struct ZeusClient ZeusClient;


#define Z_END_OF_TYPES 0


typedef enum {
    Z_END_OF_VALUES = 0,
    Z_INT,
    Z_FLOAT
} ZValueType;
typedef union {
    int int_value;
    float float_value;
} ZValue;


#ifdef Z_FORCE_INT_32
    typedef struct {
        int32_t high;
        uint32_t low;
    } ZCommandId;
#else
    typedef int64_t ZCommandId;
#endif


typedef struct {
    struct {
        ZeusClient *client;
        ZCommandId command_id;
        int role;
    } meta;

    int type[Z_MAX_COMMAND_TYPES];
    int type_length;

    ZValueType value_type[Z_MAX_COMMAND_VALUES];
    ZValue value[Z_MAX_COMMAND_VALUES];
    int value_length;
} ZCommand;


typedef struct {
    ZValueType value_type;
    ZValue value;
} ZEventValue;

typedef struct {
    struct {
        int event_id;
        struct {
            ZCommandId id;
            bool ack;
        } command;

        int roles;
        int history_size;
        bool subscribe;
    } meta;

    int *type;
    ZEventValue *value;
} ZEvent;

typedef enum {
    Z_EVENT_SENT = 0,
    Z_NOT_CONNECTED
} ZEventStatus;

ZEventValue zeus_int_value(int value);
ZEventValue zeus_float_value(float value);


#endif //CORE_COMMUNICATION_H

/** #include "src/zeus_configuration.h" expanded with it's source */

#ifndef CORE_CONFIGURATION_H
#define CORE_CONFIGURATION_H

#include <zeus_config.h>
#include <stdbool.h>

/** #include "zeus_communication.h" removed */


typedef struct {
    const int manufacturer_id;
    const int device_number;
    const char* secret;
} ZDeviceId;
extern char* Z_END_OF_TAGS;


typedef struct {
    int mask;
    const char* name;
    const char* pass;
} ZRole;
extern ZRole Z_END_OF_ROLES;

typedef const int ZRoleMask;
#define Z_ROLE_ID(id) (1 << id)
#define Z_ROLE_ANY (~0)
ZRole zeus_role(int mask, char *name, char *pass);


typedef struct {
    const ZDeviceId deviceId;
    const char** tags;
    const ZRole* roles;

    void (*on_command)(ZCommand);
} ZeusConfiguration;

#endif //CORE_CONFIGURATION_H

/** #include "src/zeus_client_state.h" expanded with it's source */

#ifndef CORE_CLIENT_STATE_H
#define CORE_CLIENT_STATE_H

#include <zeus_config.h>

/** #include "zeus_configuration.h" removed */


#ifndef ZeusTransportState
    #define ZeusTransportState int
#endif

typedef enum {
    ZEUS_NOT_CONNECTED,
    ZEUS_CONNECTING,
    ZEUS_CONNECTED
} ZeusConnectionState;

typedef enum {
    ZEUS_PLAIN_TEXT,
    ZEUS_USE_SSL
} ZeusConnectionOption;

typedef struct {
    const ZeusConnectionOption option;
    volatile ZeusConnectionState state;
    volatile int next_connection_attempt_seconds;
} ZeusConnection;


typedef enum {
    ZEUS_NOT_AUTHENTICATED,
    ZEUS_WAITING_FOR_AUTHENTICATION,
    ZEUS_AUTHENTICATED
} ZeusAuthState;

typedef struct {
    ZeusAuthState state;
    int auth_deadline_seconds;
} ZeusAuthentication;


typedef struct {
    int ping_deadline_seconds;
} ZeusPingPong;

typedef struct {
    volatile enum {
        ZEUS_WAITING_FOR_NEW_MSG,
        ZEUS_WAITING_FOR_MSG_DATA,
        ZEUS_WAITING_FOR_MSG_HANDLED,
        ZEUS_MSG_SKIPPING
    } state;

    char data[Z_RECEIVE_BUFFER_SIZE_BYTES < 64 ? 64 : Z_RECEIVE_BUFFER_SIZE_BYTES];

    volatile int data_end_pointer;

    volatile int incoming_msg_size;
    volatile int bytes_to_read;
    volatile int bytes_to_skip;

    volatile bool contains_unhandled_msg;
} ZeusBuffer;


struct ZeusClient {
    ZeusConfiguration configuration;

    ZeusConnection connection;
    ZeusAuthentication authentication;
    ZeusPingPong ping_pong;
    ZeusBuffer inbound_buffer;

    ZeusTransportState transport;
};


ZeusClient zeus_create_client(ZeusConfiguration configuration);


void zeus_run(ZeusClient *client);

#endif //CORE_CLIENT_STATE_H


ZeusClient zeus_create_client(ZeusConfiguration configuration);

void zeus_run(ZeusClient *client);

ZEventStatus zeus_send_event(ZeusClient *client, ZEvent *event);

#endif //CORE_API_H


